# Kubernetes utils

## Installation

```
pip install https://gitlab.sauerburger.com/frank/k8s-utils/-/archive/main/k8s-utils-main.zip
```


## Usage

### s3auth

Retrieve and display information about rook-ceph-based S3 users.

```
$ s3auth admin
Endpoint:   https://s3.example.com/
KeyId:      abc
SecretKey:  123supersecret
```

### softdrain

Drain a Kubernetes node by first scaling each deployment to n+1 to avoid downtime for single-pod deployments.

```
% softdrain mynode
Soft move app-namespace / backend? [y/n/c]
```

### dupvc

Run `du -s` in all PVCs in the cluster.

```
% dupvc -h
badm web-static 42M     /app/webcontent
```

## Shorthand commands

```
alias docker-nimbus='export DOCKER_HOST=ssh://nimbus'

alias kubectl-ns='kubectl config set-context --current --namespace'
alias kubectl-default='kubectl-ns default'

alias kubectl-stratus='kubectl config use-context admin@stratus && kubectl-default'
alias kubectl-nimbus='kubectl config use-context admin@nimbus && kubectl-default'

alias k='kubectl'
alias kd='kubectl describe'
alias ke='kubectl edit'
alias kg='kubectl get'
alias wkg='watch kubectl get'
alias wkt='watch kubectl top'
alias k-='kubectl delete'
alias ky='kubectl get -o yaml'
alias kl='kubectl logs -f'
alias kx='kubectl exec -it'
alias ka='kubectl apply -f'
alias kn='kubectl-ns'
alias kp='kubectl port-forward'

alias ceph='kubectl rook-ceph ceph'

alias s3='aws s3 --endpoint-url=$AWS_ENDPOINT_URL '
alias s3api='aws s3api --endpoint-url=$AWS_ENDPOINT_URL '
```